// 002 u_c_shape_list
// 18 sep 2010

// -- (C) John COLIBRI 2010
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_c_shape_list;
  interface
    uses Classes, u_i_shape_list;

    type c_rectangle=
              Class(tInterfacedObject, i_shape, i_rectangle)
              // Class(tInterfacedObject, i_rectangle)
                m_width, m_height: Integer;
                constructor create_rectangle(p_width, p_height: Integer);
                function f_surface: Integer;
                function f_width: Integer;
              end;
         c_shape_list=
              Class(tInterfacedObject, i_shape, i_shape_list)
                m_c_shape_list: tInterfaceList;

                constructor create_shape_list;
                procedure add_shape(p_i_shape: i_shape);
                function f_surface: Integer;
                destructor Destroy; Override;
              end;

  implementation
    uses SysUtils, u_c_display;

    // -- c_rectangle

    constructor c_rectangle.create_rectangle(p_width, p_height: Integer);
      begin
        m_width:= p_width;
        m_height:= p_height;
      end; // create_rectangle

    function c_rectangle.f_surface: Integer;
      begin
        Result:= m_width* m_height;
      end; // f_surface

    function c_rectangle.f_width: Integer;
      begin
      end;

    // -- c_shape_list

    constructor c_shape_list.create_shape_list;
      begin
        m_c_shape_list:= tInterfaceList.Create;
      end; // create_shape_list

    procedure c_shape_list.add_shape(p_i_shape: i_shape);
      begin
        m_c_shape_list.Add(p_i_shape);
      end; // add_shape

    function c_shape_list.f_surface: Integer;
      var l_shape_index: integer;
      begin
        Result:= 0;

        with m_c_shape_list do
          for l_shape_index:= 0 to Count- 1 do
          begin
            Result:= Result+ i_shape(m_c_shape_list[l_shape_index]).f_surface;
          end;
      end; // f_surface

    destructor c_shape_list.Destroy;
      var l_shape_index: integer;
      begin
        // for l_shape_index:= 0 to Count- 1 do
          ; // if not (

        inherited;
      end; // Destroy

end.
